#
# spec file for package cobbler
#
# Copyright (c) 2012 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
#%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

%define _binaries_in_noarch_packages_terminate_build 0
Summary:        Boot server configurator

Name:           cobbler
License:        GPLv2+
Version:        2.2.1
Release:        45.1
Source0:        cobbler-%{version}.tar.gz
Source1:        vendor-files.tar.bz2
Patch0:         fix-initscript.dif
Patch1:         suse_config.diff
Patch2:         cobbler_web_config.diff
Patch13:        users_patch.diff
Patch14:        setup_py.diff
Patch15:        virt-auto-boot.diff
Patch16:        security_fix_yaml.diff
Patch17:        cobbler_egg_cache_fix.diff
Patch18:        cobbler_csrf_fix.diff
Patch20:        security_fix_xmlrpc_command_injection.diff
Group:          Applications/System
Requires:       python >= 2.3
%if 0%{?suse_version} >= 1000
Requires:       apache2
Requires:       apache2-mod_python
Requires:       apache2-mod_wsgi
BuildRequires:  distribution-release
#Requires: tftp
Requires:       syslinux
#BuildRequires: apache2 apache2-mod_python tftp distribution-release
BuildRequires:  apache2 apache2-mod_python tftp
%else
Requires:       httpd
Requires:       tftp-server
Requires:       mod_python
%endif

Requires:       createrepo
#%if 0%{?fedora} >= 11 || 0%{?rhel} >= 6
#Requires: fence-agents
#%endif
#%if 0%{?fedora} >= 11 || 0%{?rhel} >= 6
#Requires: genisoimage
#%else
Requires:       mkisofs
#%endif
Requires:       libyaml-0-2
Requires:       python-cheetah
Requires:       python-netaddr
Requires:       python-simplejson
#%if 0%{?fedora} >= 8
#BuildRequires: python-setuptools-devel
#%else
BuildRequires:  python-setuptools
#%endif
Requires:       python-urlgrabber
Requires:       python-yaml
%if 0%{?suse_version} < 0
BuildRequires:  redhat-rpm-config
%endif
Requires:       rsync
#%if 0%{?fedora} >= 6 || 0%{?rhel} >= 5
Requires:       yum-utils
#%endif

Requires(post):  /sbin/chkconfig
Requires(preun): /sbin/chkconfig

Requires(preun): /sbin/service

%if 0%{?suse_version}
Requires(post): %fillup_prereq %insserv_prereq
Requires(preun): %fillup_prereq %insserv_prereq
Requires(preun): %fillup_prereq %insserv_prereq
%endif
#%if 0%{?fedora} >= 11 || 0%{?rhel} >= 6
#%{!?pyver: %define pyver %(%{__python} -c "import sys ; print sys.version[:3]" || echo 0)}
#Requires: python(abi) >= %{pyver}
#%endif

BuildRequires:  python-yaml
BuildRequires:  python-cheetah
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
#BuildArch: noarch
Url:            http://fedorahosted.org/cobbler

%description
Cobbler is a network install server.  Cobbler 
supports PXE, virtualized installs, and 
reinstalling existing Linux machines.  The last two 
modes use a helper tool, 'koan', that 
integrates with cobbler.  There is also a web interface
'cobbler-web'.  Cobbler's advanced features 
include importing distributions from DVDs and rsync 
mirrors, kickstart templating, integrated yum 
mirroring, and built-in DHCP/DNS Management.  Cobbler has 
a XMLRPC API for integration with other applications.

%prep
%setup -q
%setup -a1
%if 0%{suse_version}
%patch0
%patch1
%patch2
%endif
%patch13
%patch14
%patch15 -p1
%patch16 -p0
%patch17 -p0
%patch18 -p1
%patch20 -p1
mv vendor-files/cobbler.1.gz docs

%build
%{__python} setup.py build 

%install
test "x$RPM_BUILD_ROOT" != "x" && rm -rf $RPM_BUILD_ROOT
%if 0%{?suse_version} >= 1000
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/SuSEfirewall2.d
mv vendor-files/cobbler_firewall_settings $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/SuSEfirewall2.d/cobbler
PREFIX="--prefix=/usr"
mkdir -p $RPM_BUILD_ROOT/etc/apache2/vhosts.d
mkdir -p $RPM_BUILD_ROOT/srv/www/logs
%endif
%{__python} setup.py install --optimize=1 --root=$RPM_BUILD_ROOT $PREFIX
mkdir -p $RPM_BUILD_ROOT/usr/sbin
ln -sf ../../etc/init.d/cobblerd $RPM_BUILD_ROOT/usr/sbin/rccobblerd
#%if 0%{?suse_version} >= 1000
#mv $RPM_BUILD_ROOT/etc/httpd/conf.d/* $RPM_BUILD_ROOT/etc/apache2/vhosts.d/
#%endif

%post
if [ "$1" = "1" ];
then
    # This happens upon initial install. Upgrades will follow the next else
    %if 0%{?suse_version}
        %{fillup_and_insserv cobblerd}
        sysconf_addword /etc/sysconfig/apache2 APACHE_MODULES proxy
        sysconf_addword /etc/sysconfig/apache2 APACHE_MODULES python
        sysconf_addword /etc/sysconfig/apache2 APACHE_MODULES proxy_http
        sysconf_addword /etc/sysconfig/apache2 APACHE_MODULES proxy_connect
        sysconf_addword /etc/sysconfig/apache2 APACHE_MODULES wsgi
    %else
        /sbin/chkconfig --add cobblerd
    %endif

elif [ "$1" -ge "2" ];
then
    # backup config
    if [ -e /var/lib/cobbler/distros ]; then
        cp /var/lib/cobbler/distros*  /var/lib/cobbler/backup 2>/dev/null
        cp /var/lib/cobbler/profiles* /var/lib/cobbler/backup 2>/dev/null
        cp /var/lib/cobbler/systems*  /var/lib/cobbler/backup 2>/dev/null
        cp /var/lib/cobbler/repos*    /var/lib/cobbler/backup 2>/dev/null
        cp /var/lib/cobbler/networks* /var/lib/cobbler/backup 2>/dev/null
    fi
    if [ -e /var/lib/cobbler/config ]; then
        cp -a /var/lib/cobbler/config    /var/lib/cobbler/backup 2>/dev/null
    fi
    # upgrade older installs
    # move power and pxe-templates from /etc/cobbler, backup new templates to *.rpmnew
    for n in power pxe; do
      rm -f /etc/cobbler/$n*.rpmnew
      find /etc/cobbler -maxdepth 1 -name "$n*" -type f | while read f; do
        newf=/etc/cobbler/$n/`basename $f`
        [ -e $newf ] &&  mv $newf $newf.rpmnew
        mv $f $newf
      done
    done
    # upgrade older installs
    # copy kickstarts from /etc/cobbler to /var/lib/cobbler/kickstarts
    rm -f /etc/cobbler/*.ks.rpmnew
    find /etc/cobbler -maxdepth 1 -name "*.ks" -type f | while read f; do
      newf=/var/lib/cobbler/kickstarts/`basename $f`
      [ -e $newf ] &&  mv $newf $newf.rpmnew
      cp $f $newf
    done
    # reserialize and restart
    # FIXIT: ?????
    #/usr/bin/cobbler reserialize
    /sbin/service cobblerd condrestart
fi

%if 0%{?suse_version}

%preun
%stop_on_removal cobblerd

%postun
%restart_on_update cobblerd

%else

%preun
if [ $1 = 0 ]; then
    /sbin/service cobblerd stop >/dev/null 2>&1 || :
    chkconfig --del cobblerd || :
fi

%postun
if [ "$1" -ge "1" ]; then
    /sbin/service cobblerd condrestart >/dev/null 2>&1 || :
    /sbin/service apache2 condrestart >/dev/null 2>&1 || :
fi

%endif

%files

%if 0%{suse_version} > 1120
%defattr(755,root,root)
%dir /%{_sysconfdir}/sysconfig/SuSEfirewall2.d
%endif
%if 0%{suse_version}
%defattr(755,root,root)
%dir /%{_sysconfdir}/sysconfig/SuSEfirewall2.d/cobbler
%defattr(755,wwwrun,www)
%else
%defattr(755,apache,apache)
%endif
%dir /srv/www/cobbler/svc/
/srv/www/cobbler/svc/*
%{_sbindir}/rccobblerd

%defattr(755,root,root)
%dir /usr/share/cobbler
%dir /usr/share/cobbler/installer_templates
%defattr(744,root,root)
%defattr(744,root,root)
#%defattr(755,apache,apache)               (MOVED to cobbler-web)
#%dir /usr/share/cobbler/webui_templates   (MOVED to cobbler-web)
#%defattr(444,apache,apache)               (MOVED to cobbler-web)
#/usr/share/cobbler/webui_templates/*.tmpl (MOVED to cobbler-web)

%defattr(755,root,root)
%dir /var/log/cobbler
%dir /var/log/cobbler/tasks
%dir /var/log/cobbler/kicklog
%if 0%{suse_version}
%defattr(755,wwwrun,www)
%else
%defattr(755,apache,apache)
%endif
%dir /srv/www/cobbler/
%dir /srv/www/cobbler/localmirror
%dir /srv/www/cobbler/repo_mirror
%dir /srv/www/cobbler/ks_mirror
%dir /srv/www/cobbler/ks_mirror/config
%dir /srv/www/cobbler/links
#%dir /var/www/cobbler/webui (MOVED to cobbler-web)
%dir /srv/www/cobbler/aux
%if 0%{suse_version}
%defattr(444,wwwrun,www)
%else
%defattr(444,apache,apache)
%endif
#/var/www/cobbler/webui/*    (MOVED TO cobbler-web)
/srv/www/cobbler/aux/anamon
/srv/www/cobbler/aux/anamon.init

%defattr(755,root,root)
%{_bindir}/cobbler
%{_bindir}/cobbler-ext-nodes
%{_bindir}/cobblerd

%defattr(-,root,root)
%dir /etc/cobbler
%dir /etc/cobbler/pxe
%dir /etc/cobbler/reporting
%dir /etc/cobbler/power
%config(noreplace) /var/lib/cobbler/kickstarts/*.ks
%config(noreplace) /var/lib/cobbler/kickstarts/*.xml
%config(noreplace) /var/lib/cobbler/kickstarts/*.seed
%config(noreplace) /etc/cobbler/*.template
%config(noreplace) /etc/cobbler/pxe/*.template
%config(noreplace) /etc/cobbler/reporting/*.template
%config(noreplace) /etc/cobbler/power/*.template
%config(noreplace) /etc/cobbler/rsync.exclude
#%config(noreplace) /etc/logrotate.d/cobblerd_rotate
%config(noreplace) /etc/cobbler/modules.conf
%config(noreplace) /etc/cobbler/users.conf
%config(noreplace) /etc/cobbler/cheetah_macros

# new in 2.1.0
%config(noreplace)   /etc/cobbler/auth.conf
%config(noreplace)   /etc/cobbler/cobbler.conf
%config(noreplace)   /etc/cobbler/cobbler_bash
%config(noreplace)   /etc/cobbler/cobbler_web.conf
%config(noreplace)   /etc/cobbler/cobblerd
%config(noreplace)   /etc/cobbler/cobblerd_rotate
%config(noreplace)   /etc/cobbler/completions
%dir                 /etc/cobbler/ldap
%config(noreplace)   /etc/cobbler/ldap/ldap_authconfig.template
%config(noreplace)   /etc/cobbler/version

# new in 2.2.1
%dir                 /etc/cobbler/iso
%config(noreplace)   /etc/cobbler/mongodb.conf
%config(noreplace)   /etc/cobbler/iso/buildiso.template
%config(noreplace)   /etc/cobbler/cobblerd.service

%{_sbindir}/tftpd.py

%dir %{python_sitelib}/cobbler
%dir %{python_sitelib}/cobbler/modules
%{python_sitelib}/cobbler/*.py*
#%{python_sitelib}/cobbler/server/*.py*
%{python_sitelib}/cobbler/modules/*.py*
%if 0%{?fedora} >= 9 || 0%{?rhel} >= 5
%exclude %{python_sitelib}/cobbler/sub_process.py*
%endif
%{_mandir}/man1/cobbler.1.gz
/etc/init.d/cobblerd
#%if 0%{?suse_version} >= 1000
%config(noreplace) /etc/apache2/conf.d/cobbler.conf
#%config(noreplace) /etc/apache2/conf.d/cobbler_wsgi.conf
#%else
#%config(noreplace) /etc/httpd/conf.d/cobbler.conf
#%endif
%dir /var/log/cobbler/syslog
%dir /var/log/cobbler/anamon

%defattr(755,root,root)
%dir /var/lib/cobbler
%dir /var/lib/cobbler/config/
%dir /var/lib/cobbler/config/distros.d/
%dir /var/lib/cobbler/config/profiles.d/
%dir /var/lib/cobbler/config/systems.d/
%dir /var/lib/cobbler/config/repos.d/
%dir /var/lib/cobbler/config/images.d/
%dir /var/lib/cobbler/kickstarts/
%dir /var/lib/cobbler/triggers
%dir /var/lib/cobbler/triggers/change
%dir /var/lib/cobbler/triggers/add
%dir /var/lib/cobbler/triggers/add/distro
%dir /var/lib/cobbler/triggers/add/distro/pre
%dir /var/lib/cobbler/triggers/add/distro/post
%dir /var/lib/cobbler/triggers/add/profile
%dir /var/lib/cobbler/triggers/add/profile/pre
%dir /var/lib/cobbler/triggers/add/profile/post
%dir /var/lib/cobbler/triggers/add/system
%dir /var/lib/cobbler/triggers/add/system/pre
%dir /var/lib/cobbler/triggers/add/system/post
%dir /var/lib/cobbler/triggers/add/repo
%dir /var/lib/cobbler/triggers/add/repo/pre
%dir /var/lib/cobbler/triggers/add/repo/post
%dir /var/lib/cobbler/triggers/delete
%dir /var/lib/cobbler/triggers/delete/distro
%dir /var/lib/cobbler/triggers/delete/distro/pre
%dir /var/lib/cobbler/triggers/delete/distro/post
%dir /var/lib/cobbler/triggers/delete/profile
%dir /var/lib/cobbler/triggers/delete/profile/pre
%dir /var/lib/cobbler/triggers/delete/profile/post
%dir /var/lib/cobbler/triggers/delete/system
%dir /var/lib/cobbler/triggers/delete/system/pre
%dir /var/lib/cobbler/triggers/delete/system/post
%dir /var/lib/cobbler/triggers/delete/repo
%dir /var/lib/cobbler/triggers/delete/repo/pre
%dir /var/lib/cobbler/triggers/delete/repo/post
%dir /var/lib/cobbler/triggers/sync
%dir /var/lib/cobbler/triggers/sync/pre
%dir /var/lib/cobbler/triggers/sync/post
%dir /var/lib/cobbler/triggers/install
%dir /var/lib/cobbler/triggers/install/pre
%dir /var/lib/cobbler/triggers/install/post
%dir /var/lib/cobbler/snippets/

%defattr(664,root,root)
%config(noreplace) /etc/cobbler/settings
%config(noreplace) /var/lib/cobbler/snippets/*
%dir %attr(764,root,root)/var/lib/cobbler/loaders
%defattr(660,root,root)
%config(noreplace) /etc/cobbler/users.digest

%defattr(664,root,root)

%defattr(-,root,root)
%{python_sitelib}/cobbler-%{version}-py%{py_ver}.egg-info
%doc AUTHORS CHANGELOG README COPYING

%package -n koan

Summary:        Helper tool that performs cobbler orders on remote machines
Group:          Applications/System
Requires:       python >= 1.5
Requires:       python-virtinst
BuildRequires:  python-devel
%if 0%{?fedora} >= 11 || 0%{?rhel} >= 6
%{!?pyver: %define pyver %(%{__python} -c "import sys ; print sys.version[:3]")}
Requires:       python(abi) >= %{pyver}
%endif
%if 0%{?fedora} >= 8
BuildRequires:  python-setuptools-devel
%endif
%if 0%{?rhel} >= 4
BuildRequires:  python-setuptools
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
#BuildArch: noarch
Url:            http://fedorahosted.org/cobbler/

%description -n koan
Koan stands for kickstart-over-a-network and allows for both
network installation of new virtualized guests and reinstallation 
of an existing system.  For use with a boot-server configured with Cobbler

%files -n koan
%defattr(-,root,root)
# FIXME: need to generate in setup.py
#%if 0%{?fedora} > 8
#%{python_sitelib}/koan*.egg-info
#%endif
%{_bindir}/koan
%{_bindir}/cobbler-register
%dir %{python_sitelib}/koan
%{python_sitelib}/koan/*.py*
%if 0%{?fedora} >= 9 || 0%{?rhel} >= 5
%exclude %{python_sitelib}/koan/sub_process.py*
%exclude %{python_sitelib}/koan/opt_parse.py*
%exclude %{python_sitelib}/koan/text_wrap.py*
%endif
%{_mandir}/man1/koan.1.gz
%{_mandir}/man1/cobbler-register.1.gz
%dir /var/log/koan
%doc AUTHORS COPYING CHANGELOG README

%package -n cobbler-web

Summary:        Web interface for Cobbler
Group:          Applications/System
Requires:       cobbler
Requires:       python-django
Requires:       openssl
BuildRequires:  python-devel
%if 0%{?fedora} >= 11 || 0%{?rhel} >= 6
%{!?pyver: %define pyver %(%{__python} -c "import sys ; print sys.version[:3]")}
Requires:       python(abi) >= %{pyver}
%endif
%if 0%{?fedora} >= 8
BuildRequires:  python-setuptools-devel
%else
BuildRequires:  python-setuptools
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
#BuildArch: noarch
Url:            http://fedorahosted.org/cobbler/

%description -n cobbler-web
Web interface for Cobbler that allows visiting http://server/cobbler_web to configure the install server.

%post -n cobbler-web
# Change the SECRET_KEY option in the Django settings.py file
# required for security reasons, should be unique on all systems
RAND_SECRET=$(openssl rand -base64 40 | sed 's/\//\\\//g')
sed -i -e "s/SECRET_KEY = ''/SECRET_KEY = \'$RAND_SECRET\'/" /usr/share/cobbler/web/settings.py

%files -n cobbler-web
%if 0%{suse_version}
%defattr(-,wwwrun,www)
%else
%defattr(-,apache,apache)
%endif
%dir /usr/share/cobbler/web
/usr/share/cobbler/web/*
%if 0%{?suse_version} >= 1030
%config(noreplace) /etc/apache2/vhosts.d/cobbler_web.conf
%else
%config(noreplace) /etc/httpd/conf.d/cobbler_web.conf
%endif
%dir /var/lib/cobbler/webui_sessions
%dir /srv/www/cobbler_webui_content
%dir /srv/www/logs
/srv/www/cobbler_webui_content/*
%doc AUTHORS COPYING CHANGELOG README

%changelog
* Thu May 24 2012 ug@suse.de
- VUL-0: cobbler: remote code execution flaw
  bnc#763610
* Mon Apr 23 2012 ug@suse.de
- VUL-0: CVE-2011-4952:
  cobbler: multiple CSRF vulnerabilities in web interface
  bnc#757316
- Import modules, which allowed easy integration of
- Ubuntu and Debian support again!
- Better support for SuSE
- Support for FreeBSD
- Support for ESX 4+/ESXi
- Integration with the python TFTP server pytftpd
- "fetchable files" and "boot files" support for distros that need to
  get more files from the TFTP server
- Faster sync using link cache
- Support for EFI grub booting
- Support for bridged interfaces
- WSGI instead of mod_python for the web interface.
- Lots of Web UI improvements
- A lot more I'm sure I missed when going through the change log
- update to 2.2.1
* Mon Apr 16 2012 ug@suse.de
- VUL-0: CVE-2011-4953
  cobbler: privilege escalation flaw / local root
  (bnc#757062)
* Wed Mar 23 2011 ug@suse.de
- changed logfiles to root:root (bnc#678433)
* Tue Mar 22 2011 ug@suse.de
- changed permissions in /var/log/ to root:www (bnc#678433)
* Fri Mar  4 2011 ug@suse.de
- patches cleaned up
* Mon Feb 28 2011 ug@suse.de
- fixed a crash because xml.dom.ext is not available on 11.4
* Thu Feb 17 2011 ug@suse.de
- fixed the restarting of services on SUSE
* Thu Feb 17 2011 ug@suse.de
- missing rc-script link added
* Wed Feb 16 2011 ug@suse.de
- don't add "#raw" comment per default anymore
* Wed Feb 16 2011 ug@suse.de
- cobbler failed to export kickstart profiles with $SNIPPET(...)
  cheetah_class_fix.diff added for that
* Tue Feb  8 2011 ug@suse.de
- removed grubby from the requires
* Thu Feb  3 2011 ug@suse.de
- packaged the cobbler.conf instead of cobbler_wsgi.conf
  (bnc#668968)
* Wed Feb  2 2011 ug@suse.de
- spec file fixed
* Fri Jan 28 2011 ug@suse.de
- fixed apache config to avoid warning
* Wed Jan 19 2011 ug@suse.de
- added firewall config
* Thu Jan 13 2011 ug@suse.de
- version update to 2.0.10
* Wed Jan 12 2011 ug@suse.de
- some template files were not packaged
* Tue Jan 11 2011 ug@suse.de
- removed xinetd from start script
* Tue Jan 11 2011 ug@suse.de
- update to version 2.0.8
